#!/usr/bin/env ruby

input = ARGV[0] || "../submission/Park_FUN3D_VLVAF_M080s_SEEB.plt"
zone  = ARGV[1] || 1
zone = zone.to_i

model_in_to_full_feet=1.0/12.0/0.006

lines=IO.readlines('../window.csv')
col=lines[zone-1].split
puts "zone #{zone} #{col[0]}"
x0_zero = col[1].to_f
x0      = col[2].to_f
x1      = col[3].to_f
x1_ramp = col[4].to_f
x1_zero = col[5].to_f
h_full_ft = col[6].to_f

l_start=0
l_end=0

z=0
lines=IO.readlines(input)
lines.each_with_index do |line,line_number|
  if (line =~ /ZONE /) then
    puts line_number.to_s+" "+line
    z+=1;
    next
  end
  next unless (z == zone)
  break if ( z>zone)
  col=line.split
  x = col[0].to_f
  next unless (x0<=x&&x<=x1)
  l_start=line_number if (0==l_start)
  l_end = line_number
end

n =  l_end-l_start+4
puts "extracting lines #{l_start} to #{l_end}"
puts "  Number of Points = #{n}"

File.open('sboom.data','w') do |o|
  o.puts " Number of Waveforms = 1"
  o.puts " New Pressure Signature"
  o.puts "  Number of Points = #{n}"
  x = x0_zero
  p = 0.0
  o.puts "#{x*model_in_to_full_feet} #{p}"
  lines[l_start..l_end].each do |line|
    col=line.split
    x = col[0].to_f
    p = col[3].to_f
    o.puts "#{x*model_in_to_full_feet} #{p}"
  end
  x = x1_ramp
  p = 0.0
  o.puts "#{x*model_in_to_full_feet} #{p}"
  x = x1_zero
  p = 0.0
  o.puts "#{x*model_in_to_full_feet} #{p}"
end

File.open('presb.input','w') do |f|
  f.puts <<EOF
sboom.data       Name of the input file
1.6             Mach number
55000.0         Cruise Altitude
#{h_full_ft}           Starting distance of the waveform from the aircraft axis - 2 BL or 3BL depending on aircraft length
36000            Number of points to be used in the waveform during propagation
6000            Number of zero-padding points - these number of points are padded in front
1               Non-linear flag  - yes (1) or no (0)
1               Thermoviscous flag  - yes (1) or no (0)
1               Relaxation flag  - yes (1) or no (0)
0.01            Initial step size - this is dynamically controlled within sboom
1.9             Reflection factor at ground level
1000          Number of points needed in the resampled signature - do not want the output signature to have too many point
0.005           slope tolerance needed for outputting the ground signature without zero paddings - This is a sensitive parameter
1.0e-5          input tolerance
0               flag to determine whether to propagate Pressure waveform(0), F-function(1) or Equivalent Area(2)
00000.0             Height of the ground in feet
1		Number of Azimuths
0.0             azimuthal angle for off-track analysis
0               User Input Temperature Flag: 0 => Std. Atmosphere, 1 => user input
0               User Input Wind Flag: 0 => No wind, 1 => user input wind profile
0               User Input relative humidity flag: 0 => Std. Atmosphere, 1 => user input RH profile
0.0             Heading angle in degrees. 180 heading would mean away from X axis, 90 heading would mean away from Y-axis
0.0             Climb angle in degrees
0		outflag
0		Input in Inches
0		Adjoint mode flag, if 1 adjoint sboom will be run along with sboom
1		Cost function Mode (0 = orignal integral formulation, 1 = sum of pressure difference squared)

EOF
end
