#!/usr/bin/env ruby

stats=IO.readlines("stats.plt")
n = stats.length-1
puts n

vars = stats[0].split('=').last.split
puts vars

data=Hash.new
vars.each_with_index do |var,col|
  data[var]=Array.new
end

n.times do |i0|
  participant=i0+1
#  puts "#{participant} #{stats[participant].split[0]}"
  numbers = stats[participant].split
  vars.each_with_index do |var,col|
    data[var] << numbers[col].to_f
  end
end

class Array
  def median
    sorted = sort
    len = length
    return (sorted[(len - 1) / 2] + sorted[len / 2]) / 2.0
  end

  def mean
    sum = 0
    self.each do |entry|
      sum += entry
    end
    return (sum / length.to_f)
  end

  def ssd
    med = median
    sum2 = 0
    self.each do |entry|
      sum2 += (entry-med)**2
    end
    return(Math.sqrt(1.0/(length.to_f-1.0)*sum2))
  end

end

vars.each_with_index do |var,col|
  puts "#{var} #{data[var].min} #{data[var].median} #{data[var].max} #{data[var].ssd}"
end

cover = Math.sqrt(3.0)
puts "cover #{cover}"
File.open('crunch.plt','w') do |f|
  f.puts stats[0] # vars

  f.puts "ZONE T='Median' I=2"
  f.printf "0 "
  vars[1..vars.length].each do |var|
    f.printf " #{data[var].median}"
  end
  f.printf "\n"
  f.printf "70"
  vars[1..vars.length].each do |var|
    f.printf " #{data[var].median}"
  end
  f.printf "\n"

  f.puts "ZONE T='Upper' I=2"
  f.printf "0 "
  vars[1..vars.length].each do |var|
    f.printf " #{data[var].median+cover*data[var].ssd}"
  end
  f.printf "\n"
  f.printf "70"
  vars[1..vars.length].each do |var|
    f.printf " #{data[var].median+cover*data[var].ssd}"
  end
  f.printf "\n"

  f.puts "ZONE T='Lower' I=2"
  f.printf "0 "
  vars[1..vars.length].each do |var|
    f.printf " #{data[var].median-cover*data[var].ssd}"
  end
  f.printf "\n"
  f.printf "70"
  vars[1..vars.length].each do |var|
    f.printf " #{data[var].median-cover*data[var].ssd}"
  end
  f.printf "\n"
end
